-- Joinblock by Indev for Sunflower's Garden
-- Disables joining for known midjoin desynch maps to provide a better experience
local MAPS = {
	MAP55 = true, --SNES Vanilla Lake
	MAP59 = true, --Opulence
	MAP92 = true, --Forbidden Temple
	MAPA4 = true, --Digital Dimension
	MAPCW = true, --Garage Dash
	MAPDU = true, --Warehouse Skatepark
	MAPG9 = true, --Mille March
	MAPHQ = true, --Mansion of the Undead
	MAPIZ = true, --Crumbling Tower
	MAPKP = true, --Omega Rainbow Road
	MAPLS = true, --Kodachrome Palace
	MAPM6 = true, --Freefall Frenzy
	MAPME = true, --Midnight Ritual
	MAPNM = true, --Wandering Falls
	MAPPE = true, --Cosmic Eclipse Classic
	MAPPH = true, --Cosmic Eclipse Modern
	MAPR1 = true, --Dimensional Cruise
	MAPR6 = true, --Highrise Havoc
	MAPRO = true, --Final Tower
	MAPSO = true, --Classic Space Pinball
	MAPSQ = true, --New Space Pinball
	MAPT6 = true, --MK64 Mario Raceway
	MAPTL = true, --Thousand March
	MAPUA = true, --Floral Dimension
	MAPUN = true, --F-ZERO BIG BLUE
	MAPUO = true, --F-ZERO MUTE CITY
	MAPUT = true, --Bellbridge Zone
	MAPVV = true, --3DS Rock Rock Mountain
	MAPXE = true, --ChronoShift
	MAPXH = true, --ChornoShift Classic
	MAPXS = true, --Windmill Isle
	MAPYI = true, --Mushroom Spires
}

local joinblock = false

-- i wish these were a thing like leveltime
local intermissiontime = 0
local votetime = 0

local function countPlayers()
    local c = 0

    for player in players.iterate do
        if not player.spectator then
            c = c + 1
        end
    end

    return c
end

local function setJoinAllowed(allow)
    COM_BufInsertText(server, "allowjoin "..(allow and 1 or 0))
end

local function updateJoinblock(var)
    if var.value then
        setJoinAllowed(countPlayers() < 2 or not joinblock)
    else
        setJoinAllowed(true)
    end
end

local cv_joinblock = CV_RegisterVar {
    name = "joinblock",
    defaultvalue = "On",
    PossibleValue = CV_OnOff,
    flags = CV_NETVAR|CV_CALL|CV_NOINIT,
    func = updateJoinblock,
}

addHook("MapLoad", function(mapid)
    joinblock = MAPS[G_BuildMapName(mapid)]
    intermissiontime = 0
    votetime = 0
end)

addHook("ThinkFrame", function()
    if not isserver then return end

    if leveltime == 1 then
        updateJoinblock(cv_joinblock)
    end

    if joinblock and (countPlayers() < 2) then
        joinblock = false
        updateJoinblock(cv_joinblock)
    end
end)

addHook("IntermissionThinker", function()
    if not isserver then return end

    joinblock = false
    intermissiontime = $ + 1

    if intermissiontime == 1 then
        updateJoinblock(cv_joinblock)
    end
end)

addHook("VoteThinker", function()
    if not isserver then return end

    joinblock = false
    votetime = $ + 1

    if votetime == 1 then
        updateJoinblock(cv_joinblock)
    end
end)
